﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUS_FindDevice.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Sigmaｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUS : Smart-USB Sigma
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.02	M.YOSHIDA
#	
#	→	SUSﾃﾞﾊﾞｲｽの操作には｢SUSlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUSlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Sigma_xxxx.zip｣を使用してSUSﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	1,	Smart-IO2ﾎﾞｰﾄﾞを2台接続した状態で本ｻﾝﾌﾟﾙを実行して下さい。
#	2,	1台目のﾎﾞｰﾄﾞのﾛｰﾀﾘｰｽｲｯﾁを｢6｣に設定
#	3,	2台目のﾎﾞｰﾄﾞのﾛｰﾀﾘｰｽｲｯﾁを｢6｣以外に設定
#	4,	本ｻﾝﾌﾟﾙを実行すると1台目のLEDにﾗﾝﾀﾞﾑﾃﾞｰﾀがﾗｲﾄされます。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	SUSlv_FindDevice()でINDEXﾚｼﾞｽﾀに指定したINDEX値を持つﾃﾞﾊﾞｲｽを検索する。
#	2,	ﾃﾞﾊﾞｲｽが見付かれば、そのﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝする。
#	3,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する。
#	4,	ﾚｼﾞｽﾀ3が｢06h｣のﾃﾞﾊﾞｲｽを検索して一致するKX-Card7があればｵｰﾌﾟﾝを行い、
#		ﾚｼﾞｽﾀ2,8ﾋﾞｯﾄにﾗﾝﾀﾞﾑﾃﾞｰﾀをﾗｲﾄする。
#	5,	ﾚｼﾞｽﾀ3が｢04h｣のﾃﾞﾊﾞｲｽを検索して一致するAX-Card7があればｵｰﾌﾟﾝを行い、
#		ﾚｼﾞｽﾀ2,8ﾋﾞｯﾄに5Ahをﾗｲﾄする。
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUS_CONST


#	DLLを使用する時の定義
from ctypes import *

#	SUSlv.dllをﾛｰﾄﾞしてSUSlv.dll内の関数を呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUSlv.dll");

#	ﾀｰｹﾞｯﾄのﾚｼﾞｽﾀｱﾄﾞﾚｽ
_INDEX_ADRS			=	3

#	LEDﾎﾟｰﾄのﾚｼﾞｽﾀｱﾄﾞﾚｽ
_LED_ADRS			=	2

#	検索するINDEX値
_INDEX_ID_KXCARD7	=	6
_INDEX_ID_AXCARD7	=	4

#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUPlv.dll TEST PROGRAM.");
print(" SUS_FindDevice.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------');
print('');

#	----------------------------------------------------------------
#	INDEXﾚｼﾞｽﾀ(3)に指定したINDEX値(6)を持つKX-Card7を検索し見付かれば、そのﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾊﾝﾄﾞﾙを取得する
#	KX-Card7を検索する
FoundHandle = ( c_uint64 * 256 )();
if dll.SUSlv_Find_Device( _INDEX_ADRS, _INDEX_ID_KXCARD7, byref( FoundHandle )) == False:

	#	INDEX値を持つﾎﾞｰﾄﾞが見付から無かった
	print('NO Find!!');
	sys.exit(1);

#	----------------------------------------------------------------
#	見付けたﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしてPIDを表示する。
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUSlv_Usb_Open_Handle( c_uint64( FoundHandle[0] ), byref( dWinUSBHandle )) == False:
	print("SUSlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUSlv_Get_BoardInfo( dWinUSBHandle, SUS_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUSlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUSlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUSlv Device Found!!' % pid.value );

print('');


#	----------------------------------------------------------------
#	ｱﾄﾞﾚｽ2に8ﾋﾞｯﾄのﾗﾝﾀﾞﾑﾃﾞｰﾀをﾗｲﾄする。
wd = ( c_ubyte * 512 )();
wd[0] = random.randint( 0, 0xFF );
if dll.SUSlv_Reg_Write( dWinUSBHandle, _LED_ADRS, 1, byref( wd )) == False:

	#	ﾚｼﾞｽﾀﾗｲﾄ失敗
	print('REG-WRITE Failed!!\n');
	dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);

else:
	
	print('KX-Card7 Written to %02Xh\n' % wd[0] );


dll.SUSlv_Usb_Close( c_uint64( FoundHandle[0] ), dWinUSBHandle );


#	----------------------------------------------------------------
#	INDEXﾚｼﾞｽﾀ(3)に指定したINDEX値(4)を持つAX-Card7を検索し見付かれば、そのﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾊﾝﾄﾞﾙを取得する
#	AX-Card7を検索する
if dll.SUSlv_Find_Device( _INDEX_ADRS, _INDEX_ID_AXCARD7, byref( FoundHandle )) == False:

	#	INDEX値を持つﾎﾞｰﾄﾞが見付から無かった
	print('NO Find!!');
	sys.exit(1);

#	----------------------------------------------------------------
#	見付けたﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしてPIDを表示する。
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUSlv_Usb_Open_Handle( c_uint64( FoundHandle[0] ), byref( dWinUSBHandle )) == False:
	print("SUSlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUSlv_Get_BoardInfo( dWinUSBHandle, SUS_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUSlv_Usb_Close( c_uint64( FoundHandle[0] ), dWinUSBHandle );
		print('SUSlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUSlv Device Found!!' % pid.value );

print('');


#	----------------------------------------------------------------
#	ｱﾄﾞﾚｽ2に8ﾋﾞｯﾄのﾗﾝﾀﾞﾑﾃﾞｰﾀをﾗｲﾄする。
wd = ( c_ubyte * 512 )();
wd[0] = random.randint( 0, 0xFF );
if dll.SUSlv_Reg_Write( dWinUSBHandle, _LED_ADRS, 1, byref( wd )) == False:

	#	ﾚｼﾞｽﾀﾗｲﾄ失敗
	print('REG-WRITE Failed!!\n');
	dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);

else:
	
	print('AX-Card7 Written to %02Xh\n' % wd[0] );

dll.SUSlv_Usb_Close( c_uint64( FoundHandle[0] ), dWinUSBHandle );

print("FindDevice TEST Successfully!!");
print('');
