﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUS_I2CTestEx.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Sigmaｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUS : Smart-USB Sigma
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.01	M.YOSHIDA
#	
#	→	SUSﾃﾞﾊﾞｲｽの操作には｢SUSlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUSlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Sigama_xxxx.zip｣を使用してSUSﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	本ｻﾝﾌﾟﾙを実行する前に対象ﾎﾞｰﾄﾞのEXT1-IICﾎﾟｰﾄとEXT2-IICﾎﾟｰﾄにそれぞれ24LC01を接続してから実行して下さい。

#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	各ﾎﾟｰﾄに接続している24LC01にｱｸｾｽする
#	4,	128ﾊﾞｲﾄのﾗﾝﾀﾞﾑﾃﾞｰﾀﾌｧｲﾙを作成し24LC01にﾗｲﾄする
#	4,	128ﾊﾞｲﾄのﾃﾞｰﾀを24LC01からﾘｰﾄﾞする
#	5,	ﾗｲﾄﾃﾞｰﾀとﾘｰﾄﾞﾃﾞｰﾀを比較する
#	6,	128ﾊﾞｲﾄ全一致すればﾀﾞﾝﾌﾟ表示を行う
#
#	■対象ﾎﾞｰﾄﾞ■
#	KX-Card7(0303h以降)
#	CX-Card5(0302h以降)
#	AX-Card7
#
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUS_CONST

#	DLLを使用する時の定義
from ctypes import *

#	SUSlv.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUSlv.dll");

#	ﾀｰｹﾞｯﾄのﾃﾞﾊﾞｲｽｱﾄﾞﾚｽ
_DEV_ADRS		=	0xA0

#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUSlv.dll TEST PROGRAM.");
print(" SUSlv_I2CTestEx.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUSlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUSlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUSlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUSlv_Get_BoardInfo( dWinUSBHandle, SUS_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUSlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUSlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUSlv Device Found!!' % pid.value );

print('')

for k in range( 2 ):

	#	ﾗｲﾄする128ﾊﾞｲﾄの乱数生成
	wd = ( c_ubyte * 128 )();
	for i in range( 128 ):
		wd[i] = random.randint( 0, 0xFF );

	#	----------------------------------------------------
	#	24LC01へ生成した128ﾊﾞｲﾄのﾗﾝﾀﾞﾑﾃﾞｰﾀをﾗｲﾄする
	#	----------------------------------------------------
	for i in range( 128 ):

		#	IICﾗｲﾄ処理
		if dll.SUSlv_I2c_WriteEx( dWinUSBHandle, k, _DEV_ADRS, i, wd[i] ) == False:

			#	IICﾗｲﾄ失敗
			print('IIC-WRITE Failed!!\n');
			print( i );
			dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
			sys.exit(1);

		#	24LC01のﾗｲﾄｻｲｸﾙﾀｲﾑを確保
		#	5ms
		time.sleep( 0.005 )

	#	----------------------------------------------------
	#	24LC01から128ﾊﾞｲﾄをﾘｰﾄﾞする
	#	----------------------------------------------------
	rd = ( c_ubyte * 128 )();
	temp = c_ubyte();
	for i in range( 128 ):

		#	IICﾘｰﾄﾞ処理
		if dll.SUSlv_I2c_ReadEx( dWinUSBHandle, k, _DEV_ADRS, i, byref( temp )) == False:

			#	IICﾘｰﾄﾞ失敗
			print('IIC-READ Failed!!\n');
			dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
			sys.exit(1);

		else:
			rd[i] = temp.value;

	#	----------------------------------------------------
	#	ﾍﾞﾘﾌｧﾘ処理
	#	----------------------------------------------------
	for i in range( 128 ):

		if wd[i] != rd[i]:

			#	ﾍﾞﾘﾌｧｲｴﾗｰ
			print('IIC Verify ERROR!!\n');
			dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
			sys.exit(1);

	print("EXT%d-IIC Verify Successfully!!" % ( k+1 ));

	#	----------------------------------------------------
	#	24LC01からﾘｰﾄﾞしたﾃﾞｰﾀをﾀﾞﾝﾌﾟ表示
	#	----------------------------------------------------
	print("ADRS 00 01 02 03 04 05 06 07 - 08 09 0A 0B 0C 0D 0E 0F");
	i = 0;
	for j in range( 8 ):

		#	ﾀﾞﾝﾌﾟ表示
		print('%04X %02X %02X %02X %02X %02X %02X %02X %02X - %02X %02X %02X %02X %02X %02X %02X %02X' % \
		( i, rd[i+0], rd[i+1], rd[i+2], rd[i+3], \
		rd[i+4], rd[i+5], rd[i+6], rd[i+7], \
		rd[i+8], rd[i+9], rd[i+10], rd[i+11], \
		rd[i+12], rd[i+13], rd[i+14], rd[i+15] ));

		i = i + 16;

	print('');


#	ｸﾛｰｽﾞして終了
dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );

print('');
print("IIC-WriteEx/ReadEx TEST Successfully!!");
print('');
