﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUS_Temp_Alert.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Sigmaｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUS : Smart-USB Sigma
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.01	M.YOSHIDA
#	
#	→	SUSﾃﾞﾊﾞｲｽの操作には｢SUSlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUSlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Sigma_xxxx.zip｣を使用してSUSﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	現在の警告温度設定値を取得して表示する
#	4,	警告温度設定値を45度に設定する。
#	5,	警告温度設定値を取得して表示する
#
#	■対象ﾎﾞｰﾄﾞ■
#	SX-USB4(0305h以降)
#	KX-Card7(0305h以降)
#
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUS_CONST

#	DLLを使用する時の定義
from ctypes import *

#	SUSlv.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUSlv.dll");


#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUSlv.dll TEST PROGRAM.");
print(" SUS_Get_FPGA_Temp.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUSlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUSlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUSlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUSlv_Get_BoardInfo( dWinUSBHandle, SUS_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
		print('SUSlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUSlv Device Found!!' % pid.value );

print('')


#	----------------------------------------------------------------
#	3,	現在の警告温度設定値を取得して表示する
temp = c_ubyte();
if dll.SUSlv_Temp_Alert( dWinUSBHandle, SUS_CONST.TEMP_ALERT_GET, 0, byref( temp )) == False:
	dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1)

print('Current Alert Ttemperature = %d Celsius Degrees.' % temp .value );

#	4,	警告温度設定値を45度に設定する。
if dll.SUSlv_Temp_Alert( dWinUSBHandle, SUS_CONST.TEMP_ALERT_SET, 45, byref( temp )) == False:
	dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1)

print('Set Alert Ttemperature = 45 Celsius Degrees.');

#	5,	警告温度設定値を取得して表示する
if dll.SUSlv_Temp_Alert( dWinUSBHandle, SUS_CONST.TEMP_ALERT_GET, 0, byref( temp )) == False:
	dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1)

print('Current Alert Ttemperature = %d Celsius Degrees.' % temp .value );

#	ｸﾛｰｽﾞして終了
dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );

print('');
print("SUSlv_Temp_Alert TEST Successfully!!");
print('');
