﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUS_UsbDeconfig.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Sigmaｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUS : Smart-USB Sigma
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.01	M.YOSHIDA
#	
#	→	SUSﾃﾞﾊﾞｲｽの操作には｢SUSlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUSlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Sigma_xxxx.zip｣を使用してSUSﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	FPGAをIDLEﾓｰﾄﾞに移行させる
#
#	■対象ﾎﾞｰﾄﾞ■
#	Sigmaﾎﾞｰﾄﾞ全て
#
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUS_CONST

#	DLLを使用する時の定義
from ctypes import *

#	SUSlv.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUSlv.dll");


#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUSlv.dll TEST PROGRAM.");
print(" SUS_UsbDeconfig.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUSlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_ulonglong();
dWinUSBHandle = c_ulonglong();
pid = c_int();
if dll.SUSlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUSlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUSlv_Get_BoardInfo( dWinUSBHandle, SUS_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
		print('SUSlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUSlv Device Found!!' % pid.value );

print('')

#	----------------------------------------------------------------
#	FPGAをIDLEﾓｰﾄﾞに移行させる
if dll.SUSlv_Usb_Deconfig( dWinUSBHandle ) == False:
	dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
	print('SUSlv_UsbDeconfig() failed!!\n\n');
	sys.exit(1)
else:
	print("Switching to IDLE mode!!");

#	ｸﾛｰｽﾞして終了
dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );

print("Deconfig TEST Successfully!!");
print('');

