﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUS_UsbMem.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Sigmaｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUS : Smart-USB Sigma
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.01	M.YOSHIDA
#	
#	→	SUSﾃﾞﾊﾞｲｽの操作には｢SUSlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUSlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Sigma_xxxx.zip｣を使用してSUSﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	ﾒﾓﾘﾗｲﾄ→ﾒﾓﾘﾘｰﾄﾞ→比較を指定回数(_MEM_LOOP_NUM)実行する
#		ﾒﾓﾘﾌｧｲﾙのﾌｧｲﾙ名やﾚﾝｸﾞｽはﾎﾞｰﾄﾞ定義ﾌｧｲﾙにて定義しています。
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUS_CONST


#	DLLを使用する時の定義
from ctypes import *

#	SUSlv.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUSlv.dll");


#	ﾒﾓﾘﾃｽﾄﾙｰﾌﾟ回数
_MEM_LOOP_NUM	=	2

#	ﾃｽﾄで使用するﾗﾝﾀﾞﾑﾃﾞｰﾀﾌｧｲﾙ
#MEM_FILE_PATH	= 'Z:\\bin\\512MB\\Random1_512MB.bin'
MEM_FILE_PATH	= 'D:\\bin\\8MB\\Random1_8MB.bin'

#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUSlv.dll TEST PROGRAM.");
print(" SUS_UsbMem.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUSlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUSlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUSlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUSlv_Get_BoardInfo( dWinUSBHandle, SUS_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUSlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUSlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUSlv Device Found!!' % pid.value );

print('')

#	ﾀｰｹﾞｯﾄﾒﾓﾘ選択
#	ｱﾄﾞﾚｽ1,1ﾊﾞｲﾄﾚｼﾞｽﾀに1をｾｯﾄ
wd = ( c_ubyte * 512 )();
wd[0] = 0x01;
if dll.SUSlv_Reg_Write( dWinUSBHandle, 1, 1, byref( wd )) == False:

	#	ﾚｼﾞｽﾀﾗｲﾄ失敗
	print('Target Memory Select Failed!!\n');
	dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
	sys.exit(1);


#	----------------------------------------------------------------
#	ﾒﾓﾘ操作ﾙｰﾌﾟﾊﾞｯｸﾃｽﾄ
#
print( MEM_FILE_PATH );

#	ﾌｧｲﾙｻｲｽﾞを取得
FileSize = os.path.getsize( MEM_FILE_PATH );

#	ﾌｧｲﾙをﾊﾞｲﾅﾘﾓｰﾄﾞ+ﾘｰﾄﾞﾓｰﾄﾞにてｵｰﾌﾟﾝ
#	ｵｰﾌﾟﾝに失敗すると実行自体が中断される
file = open( MEM_FILE_PATH, "rb");

#	ﾊﾞｲﾅﾘﾃﾞｰﾀ読込み
#	全ﾃﾞｰﾀを取り込む
memw = file.read( FileSize );

#	ﾘｰﾄﾞ用の配列を確保
memr = create_string_buffer( FileSize );

print('%dBytes Memory TEST!!' % FileSize );
print('');

for loop in range( 0, _MEM_LOOP_NUM ):

	#	ﾒﾓﾘﾗｲﾄ実行
#	print('MemWriting ........ ', end='');
#	start_time = time.time();	#	←ここからの時間をﾃﾞｰﾀ転送時間とする
#	if dll.SUSlv_Data_Write( dWinUSBHandle, FileSize, memw ) == False:
#
#		#	ﾒﾓﾘﾗｲﾄ失敗
#		print(' Failed!!');
#		dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
#		sys.exit(1);

#	else:
#
#		#	ﾒﾓﾘﾗｲﾄ成功
#		elapsed_time = ( time.time() - start_time ) * 1000;
#		print(' Successfully!!');
#		print('MemWrite Transfer time = %dms' % elapsed_time );
#		print('MemWrite Transfer rate = %3.2fMB/s\n' % ( FileSize  / ( elapsed_time * 1000 )));

	#	ﾒﾓﾘﾘｰﾄﾞ処理
	print('Memreading ........ ', end='');
	start_time = time.time();	#	←ここからの時間をﾃﾞｰﾀ転送時間とする
	if dll.SUSlv_Data_Read( dWinUSBHandle, FileSize, memr ) == False:

		#	ﾒﾓﾘﾘｰﾄﾞ失敗
		print(' Failed!!');
		dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

	else:

		#	ﾒﾓﾘﾘｰﾄﾞ成功
		elapsed_time = ( time.time() - start_time ) * 1000;
		print(' Successfully!!');
		print('MemRead Transfer time = %ldms' % elapsed_time );
		print('MemRead Transfer rate = %3.2fMB/s\n' % ( FileSize  / ( elapsed_time * 1000 )));

	#	ｺﾝﾍﾟｱ処理
	print('During Verify .', end='');
	for i in range( 0, FileSize ):
		if ord( memr[i] ) != memw[i]:
			print('NG!! ADRS=%08Xh, MEMW=%02Xh, MEMR=%02Xh' % ( i, memw[i], memr.value[i] ));

		if(( i % ( 5000000 )) == 0 ):
			print('.', end='', flush=True);

	print(' DONE!!');

	print('---- LOOP %04d, Memory Verify Successfully!! ----' % loop );
	print('');




#	ｸﾛｰｽﾞして終了
dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );

print("SUSlv_Data_Write/Read TEST Successfully!!");
print('');
