﻿# -*- coding: utf-8 -*-
#	----------------------------------------------------------------
#   SUS_UsbReg.py ｿｰｽﾌｧｲﾙ
#	Smart-USB Sigmaｼﾘｰｽﾞ用 Pythonｻﾝﾌﾟﾙﾌﾟﾛｸﾞﾗﾑ
#	
#	SUS : Smart-USB Sigma
#         ^     ^   ^
#	
#	python-3.6.0a1-amd64をWindows7@64ﾋﾞｯﾄ環境にｲﾝｽﾄｰﾙして動作確認を行った。
#	
#	2017.06.01	M.YOSHIDA
#	
#	→	SUSﾃﾞﾊﾞｲｽの操作には｢SUSlv.dll｣を使用する。
#	→	ｶﾚﾝﾄﾃﾞｨﾚｸﾄﾘにSUSlv.dllをｺﾋﾟｰしてから実行する。
#	→	事前に｢DPInst_Sigma_xxxx.zip｣を使用してSUSﾃﾞﾊﾞｲｽのﾃﾞﾊﾞｲｽﾄﾞﾗｲﾊﾞをｲﾝｽﾄｰﾙする必要がある。
#		"xxxx"はﾄﾞﾗｲﾊﾞﾊﾞｰｼﾞｮﾝ
#	
#	保存時の文字ｺｰﾄﾞを ｢UTF-8｣形式 で設定すること。
#	
#	■ｻﾝﾌﾟﾙ内容■
#	
#	1,	最初に見付けたﾎﾞｰﾄﾞをｵｰﾌﾟﾝする
#	2,	ｵｰﾌﾟﾝしたﾎﾞｰﾄﾞのPIDを取得して表示する
#	3,	ﾚｼﾞｽﾀ6-512ﾊﾞｲﾄﾚｼﾞｽﾀにﾗｲﾄ→ﾘｰﾄﾞ→比較を指定回数(_REG_LOOP_NUM)実行する
#	4,	ﾚｼﾞｽﾀ2097151-32ﾋﾞｯﾄにﾗｲﾄﾘｰﾄﾞ→比較を指定回数(_REG_LOOP_NUM)実行する
#	
#	----------------------------------------------------------------
#
import	sys
import	time
import	random
import	os.path
import	SUS_CONST

#	DLLを使用する時の定義
from ctypes import *

#	SUSlv.dllをﾛｰﾄﾞして呼び出し可能な状態にする。
dll = windll.LoadLibrary("SUSlv.dll");


#	ﾚｼﾞｽﾀﾃｽﾄﾙｰﾌﾟ回数
_REG_LOOP_NUM	=	16

#	ﾀｰｹﾞｯﾄのﾚｼﾞｽﾀｱﾄﾞﾚｽ
_REG_ADRS1		=	6
_REG_ADRS2		=	2097151



#	----------------------------------------------------------------
#	起動表示
print('------------------------------------------------\n');
print(" Python3.6 & SUSlv.dll TEST PROGRAM.");
print(" SUS_UsbReg.py Version 1.00(BETA)");
print(" Copyright(C) 2004-2017, Prime Systems, Inc.\n");
print('------------------------------------------------\n');


#	----------------------------------------------------------------
#	SUSlvﾃﾞﾊﾞｲｽをｵｰﾌﾟﾝしﾊﾝﾄﾞﾙを取得
FoundHandle = c_uint64();
dWinUSBHandle = c_uint64();
pid = c_int();
if dll.SUSlv_Usb_Open( byref( FoundHandle ), byref( dWinUSBHandle )) == False:
	print("SUSlv device not found!!");
	sys.exit(1);
else:

	#	----------------------------------------------------------------
	#	ﾎﾞｰﾄﾞ情報の取得
	if dll.SUSlv_Get_BoardInfo( dWinUSBHandle, SUS_CONST.BOARDINFO_PID, byref( pid )) == False:
		dll.SUSlv_Usb_Close( dFoundHandle, dWinUSBHandle );
		print('SUSlv_Get_BoardInfo() failed!!\n\n');
		sys.exit(1);
	else:
		print('PID:%04Xh SUSlv Device Found!!' % pid.value );

print('');

#	----------------------------------------------------------------
#	ﾚｼﾞｽﾀﾙｰﾌﾟﾊﾞｯｸﾃｽﾄ
#	ﾚｼﾞｽﾀ6にｱｸｾｽする
#
#	乱数を生成してﾚｼﾞｽﾀﾗｲﾄ→ﾚｼﾞｽﾀﾘｰﾄﾞして比較を指定回数実行する
#
rd = ( c_ubyte * 512 )();
wd = ( c_ubyte * 512 )();
print('REG6 LOOP TEST!!');
for i in range( _REG_LOOP_NUM ):

	#	乱数生成
	for j in range( 512 ):
		wd[j] = random.randint( 0, 0xFF );

	#	ﾚｼﾞｽﾀﾗｲﾄ
	#	ｱﾄﾞﾚｽ6,512ﾊﾞｲﾄﾚｼﾞｽﾀ
	if dll.SUSlv_Reg_Write( dWinUSBHandle, _REG_ADRS1, 512, byref( wd )) == False:

		#	ﾚｼﾞｽﾀﾗｲﾄ失敗
		print('REG-WRITE Failed!!\n');
		dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

	#	ﾚｼﾞｽﾀﾘｰﾄﾞ
	if dll.SUSlv_Reg_Read( dWinUSBHandle, _REG_ADRS1, 512, byref( rd )) == False:

		#	ﾚｼﾞｽﾀﾘｰﾄﾞ失敗
		print('REG-READ Failed!!\n');
		dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

	#	ﾍﾞﾘﾌｧｲ処理
	for j in range( 512 ):
		if wd[j] != rd[j]:

			#	ﾍﾞﾘﾌｧｲNG
			print('LOOP %04d NG:%02Xh,%02Xh' % ( i, wd[j], rd[j] ));
			dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
			sys.exit(1);

	print('LOOP %04d DONE!!' % i );
print('');


#	----------------------------------------------------------------
#	ﾚｼﾞｽﾀﾙｰﾌﾟﾊﾞｯｸﾃｽﾄ
#	ﾚｼﾞｽﾀ4-16ﾋﾞｯﾄにｱｸｾｽする
#
#	乱数を生成してﾚｼﾞｽﾀﾗｲﾄ→ﾚｼﾞｽﾀﾘｰﾄﾞして比較を指定回数実行する

rd = ( c_ubyte * 4 )();
wd = ( c_ubyte * 4 )();
print('REG2097151 LOOP TEST!!');

for i in range( _REG_LOOP_NUM ):

	#	乱数生成
	wd[0] = random.randint( 0, 0xFF );
	wd[1] = random.randint( 0, 0xFF );
	wd[2] = random.randint( 0, 0xFF );
	wd[3] = random.randint( 0, 0xFF );

	#	ﾚｼﾞｽﾀﾗｲﾄ
	if dll.SUSlv_Reg_Write( dWinUSBHandle, _REG_ADRS2, 4, byref( wd )) == False:

		#	ﾚｼﾞｽﾀﾗｲﾄ失敗
		print('REG-WRITE Failed!!\n');
		dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

	#	ﾚｼﾞｽﾀﾘｰﾄﾞ
	#	ｱﾄﾞﾚｽ4,16ﾋﾞｯﾄ固定
	if dll.SUSlv_Reg_Read( dWinUSBHandle, _REG_ADRS2, 4, byref( rd )) == False:

		#	ﾚｼﾞｽﾀﾘｰﾄﾞ失敗
		print('REG-READ Failed!!\n');
		dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
		sys.exit(1);

	#	ﾍﾞﾘﾌｧｲ処理
	for j in range( 4 ):

		if wd[j] != rd[j]:

			#	ﾍﾞﾘﾌｧｲNG
			print('LOOP %04d NG:%08Xh,%08Xh' % ( i, wd, rd.value ));
			dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );
			sys.exit(1);

	print('LOOP %04d DONE!!' % i );
print('');

#	ｸﾛｰｽﾞして終了
dll.SUSlv_Usb_Close( FoundHandle, dWinUSBHandle );

print("REG TEST Successfully!!");
print('');

